#include "fastbf.h"
#include <stdint.h>
#include <stdio.h>

/*
simon@gamerarch:~/W/fastbf$ time ./bf < bench.bf
OK
real    0m0,680s
user    0m0,676s
sys     0m0,004s
simon@gamerarch:~/W/fastbf$ time ./bf < bench.bf
OK
real    0m0,682s
user    0m0,677s
sys     0m0,003s
simon@gamerarch:~/W/fastbf$ time ./bf < bench.bf
OK
real    0m0,679s
user    0m0,679s
sys     0m0,000s
*/

void v1(const char* program, size_t length)
{
    (void)length;
    uint8_t memory[30000];
    uint_fast16_t memory_index = 0;
    for (uint_fast16_t i = 0; i < length; i++) {
        char c = program[i];
        switch (c) {
            case '+':
                memory[memory_index]++;
                break;
            case '-':
                memory[memory_index]--;
                break;
            case '>':
                memory_index++;
                break;
            case '<':
                memory_index--;
                break;
            case '.':
                putc(memory[memory_index], stdout);
                break;
            case ',':
                memory[memory_index] = (uint8_t)getc(stdin);
                break;
            case ']':
                if (memory[memory_index]) {
                    int depth = 1;
                    while (program[i] != '[' || depth != 0) {
                        i--;
                        if (program[i] == ']')
                            depth++;
                        else if (program[i] == '[')
                            depth--;
                    }
                }
                break;
        }
    }
}
